/*
	Vertris v0.3.2
	Copyright (C) 2006 - 2007, Andrs Rassol
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <string.h>

#include <allegro.h>

#include "vertris.h"

extern unsigned int Lines, Max_Lines[MAX_HISCORES], Score, Max_Score[MAX_HISCORES];
extern char Max_Name[MAX_HISCORES][NAME_LENGTH];
extern int Redraw_All;

char Show_HiScores, Show_Name_Input, Name[NAME_LENGTH];

void swap(unsigned int *a, unsigned int *b)
{
	unsigned int t;

	t = *a;
	*a = *b;
	*b = t;
}

void str_swap(char *a, char *b)
{
	char s[NAME_LENGTH];

	ustrcpy(s, a);
	ustrcpy(a, b);
	ustrcpy(b, s);
}

void bubble_sort()
{
	int i, j;

	for (i = MAX_HISCORES; i--; )
		for (j = 0; j < i; j++)
			if (Max_Score[j] < Max_Score[j+1])
			{
				swap(&Max_Score[j], &Max_Score[j+1]);
				swap(&Max_Lines[j], &Max_Lines[j+1]);
				str_swap(Max_Name[j], Max_Name[j+1]);
			}
}

void input_name()
{
	int ukey, i;
	char t[2];

	Name[0] = '\0';
	Show_Name_Input = 1;

	clear_keybuf();

	while (ustrlen(Name) <= NAME_LENGTH - 1)
	{
		Redraw_All = 1;

		while (!keypressed())
			output();

		ukey = ureadkey(NULL);

		if (key[KEY_SPACE])
			ukey = '_';
		else if (key[KEY_ENTER])
		{
			Show_Name_Input = 0;
			return;
		}
		else if (key[KEY_BACKSPACE])
			for (i = 1; i < NAME_LENGTH; i++)
				if (Name[i] == '\0')
				{
					Name[i-1] = '\0';
					break;
				}

		if (ukey < ' ')
			continue;

		t[0] = ukey;
		t[1] = '\0';
		ustrzcat(Name, NAME_LENGTH, t);
	}

	Show_Name_Input = 0;
}

int is_hiscore()
{
	if (Score > Max_Score[MAX_HISCORES - 1] ||
	(Score == Max_Score[MAX_HISCORES - 1] &&
	Lines < Max_Lines[MAX_HISCORES - 1]))
		return 1;

	return 0;
}


void hiscores()
{
	if (is_hiscore())
	{
		input_name();
		strcpy(Max_Name[MAX_HISCORES - 1], Name);
		Max_Score[MAX_HISCORES - 1] = Score;
		Max_Lines[MAX_HISCORES - 1] = Lines;

		bubble_sort();
	}

	Redraw_All = 1;
	Show_HiScores = 1;
	clear_keybuf();

	key[KEY_ENTER] = 0;

	while (!key[KEY_ENTER])
		output();

	clear_keybuf();
	Show_HiScores = 0;
	new_game();
}
